
#include "cs.h"

extern void deact(INSDS*);

static void infoff(MYFLT p1)           /*  turn off an indef copy of instr p1  */
{                               /*      called by musmon                */
    INSDS *ip;
    int   insno;
//      extern INSTRTXT **instrtxtp;       IV - Aug 23 2002
    insno = (int)p1;
    if ((ip = (instrtxtp[insno])->instance) != NULL) {
      do  if (ip->insno == insno          /* if find the insno */
          && ip->actflg                 /*      active       */
          //&& ip->offtim < 0             /*      but indef,   */
          && ip->p1 == p1) {
        VMSG(printf("turning off inf copy of instr %d\n",insno);)
        deact(ip);
        return;                     /*  turn it off */
      }
      while ((ip = ip->nxtinstance) != NULL);
    }
    //printf(Str(X_669,"could not find indefinitely playing instr %d\n"),insno);
}

void ButtonSched(MYFLT  *args[], int numargs)
{ /* based on code by rasmus */
    int i, absinsno, argnum;
    MYFLT insno, starttime;
    EVTNODE *evtlist, *newnode;
    EVTBLK  *newevt;

    /* Get absolute instr num */
    insno = *args[1];
    if (insno < FL(0.0)) {
      infoff(-insno);
      return;
    }
    absinsno = abs((int)insno);
    /* Create the new event */
    newnode = (EVTNODE *) mmalloc((long)sizeof(EVTNODE));
    newevt = &newnode->evt;
    newevt->opcod = (char) *args[0];
    if (newevt->opcod == 0) newevt->opcod = 'i';
    /* Set start time from kwhen */
    starttime = *args[2];
    if (starttime < FL(0.0)) {
      starttime = FL(0.0);
    }
    /* Add current time (see note about kadjust in triginset() above) */
    starttime += (MYFLT) (global_kcounter-1L) * global_onedkr;  // IV - Sep 8 2002
    newnode->kstart = (long)(starttime * global_ekr + FL(0.5)); // IV - Sep 8 2002
    newevt->p2orig = starttime;
    newevt->p3orig = *args[3];
    /* Copy all arguments to the new event */
    newevt->pcnt = (argnum = numargs) -1;
    for (i = 1; i < argnum; i++)
      newevt->p[i] = *args[i];
    newevt->p[2] = starttime;    /* Set actual start time in p2 */

    newnode->insno = absinsno;
    /* Set event activation time in k-cycles */
    newnode->kstart = (long)(starttime * global_ekr + FL(0.5)); // IV - Sep 8 2002

    /* Insert eventnode in list of generated events */
    evtlist = &OrcTrigEvts;
    while (evtlist->nxtevt) {
      if (newnode->kstart < evtlist->nxtevt->kstart) break;
      evtlist = evtlist->nxtevt;
    }
    newnode->nxtevt = evtlist->nxtevt;
    evtlist->nxtevt = newnode;
    O.RTevents = 1;     /* Make sure kperf() looks for RT events */
    O.ksensing = 1;
    O.OrcEvts  = 1;     /* - of the appropriate type */
}

